#include "ethertap.h"
#include <unistd.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#include <fcntl.h>
#include <error.h>
#include <errno.h>
#include <sys/errno.h>
#include <string.h>
#include <signal.h>

#define BLOCK_SIZE 4096

ethertap::ethertap(char *t)
 {
  len = 0;
  buf = new char[BLOCK_SIZE];
  fd = ::open(t, O_RDWR);
  if (fd < 0) throw couldNotOpen();
 }

ethertap::~ethertap()
 {
  delete [] buf;
  close(fd);
 }
   
void ethertap::read()
 {
  len = ::read(fd, buf, BLOCK_SIZE);
  if (len <= 0) throw couldNotRead();
 }

int ethertap::getBufLen()
 {
  return len;
 }
 
char *ethertap::getBuf()
 {
  return buf;
 }
 
void ethertap::write(char *d, int s)
 {
  if (::write(fd, d, s) != s) throw couldNotWrite();
 }
  
ethertap::operator int()
 {
  return fd;
 }
  
